﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace dcom_test_visual
{
    public partial class Form1 : Form
    {
        WMDocImpServer.WMDocImpObject o;
        WMDocImpServer.WMDocImpObject[] oa;

        void InitDocImpServer()
        {
            if (o == null)
            { 
                o = new WMDocImpServer.WMDocImpObject();
                LogOutput("DocImpServer instantiat");
            }
        }

        void InitDocImpServerArr(int n)
        {
            if (oa == null)
            {
                oa = new WMDocImpServer.WMDocImpObject[n];
                for (int i = 0; i < n; i++)
                {
                    oa[i] = new WMDocImpServer.WMDocImpObject();
                    LogOutput("DocImpServer" + i + " instantiat");
                }
               
            }
        }

        public Form1()
        {
            InitializeComponent();
        //    InitDocImpServerArr(2);
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        void LogOutput(string text)
        {
            textBox13.AppendText(text);
            textBox13.AppendText(Environment.NewLine);
        }

        void LogErrors(string text)
        {
            dynamic le = o.GetListaErori();
            if (le != null)
            {
                textBox13.AppendText("Eroare: " + text);
                textBox13.AppendText(Environment.NewLine);

                string les = string.Join("\n", le);
                textBox13.AppendText(les);
                textBox13.AppendText(Environment.NewLine);
            }
            else
            {
                textBox13.AppendText("Nicio eroare: " + text);
                textBox13.AppendText(Environment.NewLine);
            }
        }

        void LogError(string text)
        {
            dynamic le = o.GetListaErori();
            if( le != null)
            {
                textBox13.AppendText("Eroare: " + text);
                textBox13.AppendText(Environment.NewLine);

                string les = string.Join("\n", le);
                textBox13.AppendText(les);
                textBox13.AppendText(Environment.NewLine);
            }  
            else
            {
                textBox13.AppendText("Nicio eroare, rezultat nul: " + text);
                textBox13.AppendText(Environment.NewLine);
            }
        }

        void LogError(int index, string text)
        {
            dynamic le = oa[index].GetListaErori();
            if (le != null)
            {
                textBox13.AppendText("DocImpServer " + index + " Eroare: " + text);
                textBox13.AppendText(Environment.NewLine);

                string les = string.Join("\n", le);
                textBox13.AppendText(les);
                textBox13.AppendText(Environment.NewLine);
            }
            else
            {
                textBox13.AppendText("Nicio eroare, rezultat nul: " + text);
                textBox13.AppendText(Environment.NewLine);
            }
        }

        void LogError(WMDocImpServer.WMDocImpObject w, string text)
        {
            dynamic le = w.GetListaErori();
            if (le != null)
            {
                textBox13.AppendText(" Eroare: " + text);
                textBox13.AppendText(Environment.NewLine);

                string les = string.Join("\n", le);
                textBox13.AppendText(les);
                textBox13.AppendText(Environment.NewLine);
            }
            else
            {
                textBox13.AppendText("Nicio eroare, rezultat nul: " + text);
                textBox13.AppendText(Environment.NewLine);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //   WMDocImpServer.WMDocImpObject o = new WMDocImpServer.WMDocImpObject();
            //    o.LogOn("GABI", "1");
            InitDocImpServer();
            string user = textBox6.Text;
            string pwd = textBox5.Text;
            int res = o.LogOn(user, pwd);
            if (res == 0)
                LogError("LogOn(" + user + ", " + pwd + ")");
            else
                LogOutput("LogOn(" + user + ", " + pwd + ")");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            string firma = textBox4.Text;
            int res = o.SetNumeFirma(firma);
            if (res == 0)
                LogError("SetNumeFirma(" + firma + ")");
            else
                LogOutput("SetNumeFirma(" + firma + ")");
        }

        private void textBox4_TextChanged(object sender, EventArgs e)
        {

        }

        private void button3_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            string den = textBox3.Text;
            int res = o.SetDenSubunit(den);
            if (res == 0)
                LogError("SetDenSubunit(" + den + ")");
            else
                LogOutput("SetDenSubunit(" + den + ")");
        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {

        }

        private void button4_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            int luna = Int32.Parse(textBox8.Text);
            int an = Int32.Parse(textBox7.Text);
            int res = o.SetLunaLucru(an, luna);
            if (res == 0)
                LogError("SetLunaLucru(" + an + ", " + luna + ")");
            else
                LogOutput("SetLunaLucru(" + an + ", " + luna + ")");
        }

        private void textBox8_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox7_TextChanged(object sender, EventArgs e)
        {

        }

        private void button5_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            string id = textBox9.Text;
            o.SetIDPartField(id);
            /*
            if (res == 0)
                LogError("SetDenSubunit(" + den + ")");
            else
            */
                LogOutput("SetIDPartField(" + id + ")");
        }

        private void textBox9_TextChanged(object sender, EventArgs e)
        {

        }

        private void button6_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            string id = textBox11.Text;
            o.SetIDArtField(id);
            /*
            if (res == 0)
                LogError("SetDenSubunit(" + den + ")");
            else
            */
                LogOutput("SetIDArtField(" + id + ")");
        }

        private void textBox11_TextChanged(object sender, EventArgs e)
        {
      
        }

        private void button7_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            dynamic arr = o.GetListaFirme();
            if (arr == null)
                LogError("GetListaFirme()");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetListaFirme()");
                LogOutput(s);
            }
           
        }

        private void button8_Click(object sender, EventArgs e)
        {
            int err = -1;
            InitDocImpServer();
            dynamic arr = o.GetListaSubunit(out err);
            if (arr == null)
                LogError("GetListaSubunit()");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetListaSubunitati()");
                LogOutput(s);
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            int err = -1;
            InitDocImpServer();
            dynamic arr = o.GetComenziNefacturate(out err);
            if (arr == null)
                LogError("GetComenziNefacturate()");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetComenziNefacturate()");
                LogOutput(s);
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            int cod_cmd = Int32.Parse(textBox1.Text);
            int status = Int32.Parse(textBox2.Text);
            int res = o.SetStadiuWMSComanda(cod_cmd, status);
            if (res == 0)
                LogError("SetStadiuWMSComanda(" + cod_cmd + ", " + status + ")");
            else
                LogOutput("SetStadiuWMSComanda(" + cod_cmd + ", " + status + ")");
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }

        private void button11_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            int err = -1;
            int cod_cmd = Int32.Parse(textBox10.Text);
            dynamic arr = o.GetLiniiComandaNefacturata(cod_cmd, out err);
            if (arr == null)
                LogError("GetLiniiComandaNefacturata("+ cod_cmd + ")");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetLiniiComandaNefacturata(" + cod_cmd + ")");
                LogOutput(s);
            }
        }

        private void button12_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            string txt = textBox12.Text;
     //       string[] listaLinii = txt.Split(new[] { "\r\n", "\r", "\n" }, StringSplitOptions.None);
            string[] listaLinii = txt.Split(new[] { "\r\n", "\r", "\n" }, StringSplitOptions.RemoveEmptyEntries);

            int res = o.SetCantitatiLiniiComanda(listaLinii);
            if (res == 0)
                LogError("SetCantitatiLiniiComanda()");
            else
                LogOutput("SetCantitatiLiniiComanda()");
        }

        private void textBox12_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox10_TextChanged(object sender, EventArgs e)
        {

        }

        private void button13_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            int err = -1;
            dynamic arr = o.GetCmdFurnNefacturate(out err);
            if (arr == null)
                LogError("GetLiniiComandaNefacturata()");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetLiniiComandaNefacturata()");
                LogOutput(s);
            }
        }

        private void button14_Click(object sender, EventArgs e)
        {
            InitDocImpServer();
            int err = -1;
            dynamic arr = o.GetSolduriExt(out err);
            LogErrors("GetSolduriExt()");
            if (arr == null)
                LogError("GetSolduriExt()");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetSolduriExt()");
                LogOutput(s);
            }
        }


        void MethodChain ()
        {
            InitDocImpServerArr(3);

            LogOutput("3 instante de docimpserver, prima apeleaza GetListaFirme, a doua apeleaza SetNumeFirma, GetListaSubunitati, a treia SetNumeFirma, SetLunaLucru");

            string user = textBox6.Text;
            string pwd = textBox5.Text;

            string[] users = new string[3];
            string[] passes = new string[3];
            users[0] = "gabi";
            passes[0] = "1";
            users[1] = "valentin";
            passes[1] = "1";
            users[2] = "gseica";
            passes[2] = "1";


            for (int i = 0; i < 3; i++)
            {
                int res2 = oa[i].LogOn(users[i], passes[i]);
                if (res2 == 0)
                    LogError(0, "LogOn(" + users[i] + ", " + passes[i] + ")");
                else
                    LogOutput("LogOn(" + users[i] + ", " + passes[i] + ")");
            }

            //--- 1

            dynamic arr = oa[0].GetListaFirme();
            if (arr == null)
                LogError(0, "GetListaFirme()");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetListaFirme()");
                LogOutput(s);
            }

            oa[0] = null;

            // --- 2

            string firma = textBox4.Text;
            int res = oa[1].SetNumeFirma(firma);
            if (res == 0)
                LogError(1, "SetNumeFirma(" + firma + ")");
            else
                LogOutput("SetNumeFirma(" + firma + ")");


            int err = -1;
            arr = oa[1].GetListaSubunit(out err);
            if (arr == null)
                LogError(1, "GetListaSubunit()");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetListaSubunitati()");
                LogOutput(s);
            }

            oa[1] = null;


            //------------- 3

            firma = textBox4.Text;
            res = oa[2].SetNumeFirma(firma);
            if (res == 0)
                LogError(2, "SetNumeFirma(" + firma + ")");
            else
                LogOutput("SetNumeFirma(" + firma + ")");


            int luna = Int32.Parse(textBox8.Text);
            int an = Int32.Parse(textBox7.Text);
            res = oa[2].SetLunaLucru(an, luna);
            if (res == 0)
                LogError(2, "SetLunaLucru(" + an + ", " + luna + ")");
            else
                LogOutput("SetLunaLucru(" + an + ", " + luna + ")");

            oa[2] = null;

            foreach (var process in Process.GetProcessesByName("WMDocImpServer"))
            {
                process.Kill();
                LogOutput(process.MachineName + " " + process.Id + " is kill");
            }
        }

       WMDocImpServer.WMDocImpObject o1, o2;

        private void button15_Click(object sender, EventArgs e)
        {
            if (o1 == null)
            {
                o1 = new WMDocImpServer.WMDocImpObject();
                LogOutput("DocImpServer instantiat");
            }

            string user = textBox14.Text;
            string pwd = textBox15.Text;
            int res = o1.LogOn(user, pwd);
            if (res == 0)
                LogError(o1, "server 1 LogOn(" + user + ", " + pwd + ")");
            else
                LogOutput("server 1 LogOn(" + user + ", " + pwd + ")");

        }

        private void label9_Click(object sender, EventArgs e)
        {
        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void button16_Click(object sender, EventArgs e)
        {
            if (o2 == null)
            {
                o2 = new WMDocImpServer.WMDocImpObject();
                LogOutput("DocImpServer instantiat");
            }

            string user = textBox17.Text;
            string pwd = textBox16.Text;
            int res = o2.LogOn(user, pwd);
            if (res == 0)
                LogError(o2, "server 2 LogOn(" + user + ", " + pwd + ")");
            else
                LogOutput("server 2 LogOn(" + user + ", " + pwd + ")");
        }

        private void button17_Click(object sender, EventArgs e)
        {
            dynamic arr = o1.GetListaFirme();
            if (arr == null)
                LogError(o1, "GetListaFirme()");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetListaFirme()");
                LogOutput(s);
            }

            Marshal.ReleaseComObject(o1);
            o1 = null;
        }

        private void label11_Click(object sender, EventArgs e)
        {

        }

        private void label12_Click(object sender, EventArgs e)
        {

        }

        private void textBox18_TextChanged(object sender, EventArgs e)
        {

        }

        private void button18_Click(object sender, EventArgs e)
        {
            string firma = textBox18.Text;
            int res = o2.SetNumeFirma(firma);
            if (res == 0)
                LogError(o2, "SetNumeFirma(" + firma + ")");
            else
                LogOutput("SetNumeFirma(" + firma + ")");


            int err = -1;
            dynamic arr = o2.GetListaSubunit(out err);
            if (arr == null)
                LogError(o2, "GetListaSubunit()");
            else
            {
                string s = string.Join(Environment.NewLine, arr);
                LogOutput("GetListaSubunitati()");
                LogOutput(s);
            }

            Marshal.ReleaseComObject(o2);
            o2 = null;
        }
    }
}
